## cbmc 5.1

=== src/Makefile ===
DIRS = ansi-c big-int cbmc cpp goto-cc goto-instrument goto-programs \
       goto-symex langapi pointer-analysis solvers util linking xmllang \
       assembler analyses java_bytecode aa-path-symex path-symex musketeer \
       json

all: cbmc.dir goto-cc.dir goto-instrument.dir path-symex.dir json.dir

###############################################################################

util.dir: big-int.dir

# everything depends on util
$(patsubst %, %.dir, $(filter-out big-int util, $(DIRS))): util.dir

.PHONY: languages
.PHONY: clean

cpp.dir: ansi-c.dir linking.dir

languages: util.dir langapi.dir \
           cpp.dir ansi-c.dir xmllang.dir assembler.dir java_bytecode.dir

goto-instrument.dir: languages goto-programs.dir pointer-analysis.dir \
                     goto-symex.dir linking.dir analyses.dir solvers.dir

musketeer.dir: goto-instrument.dir

cbmc.dir: languages solvers.dir goto-symex.dir analyses.dir \
          pointer-analysis.dir goto-programs.dir linking.dir

goto-cc.dir: languages pointer-analysis.dir goto-programs.dir linking.dir

# building for a particular directory

$(patsubst %, %.dir, $(DIRS)):
	## Entering $(basename $@)
	$(MAKE) $(MAKEARGS) -C $(basename $@)

# generate source files

$(patsubst %, %_generated_files, $(DIRS)):
	$(MAKE) $(MAKEARGS) -C $(patsubst %_generated_files, %, $@) generated_files
	
generated_files: $(patsubst %, %_generated_files, $(DIRS))

# cleaning

clean: $(patsubst %, %_clean, $(DIRS))

$(patsubst %, %_clean, $(DIRS)):
	$(MAKE) $(MAKEARGS) -C $(patsubst %_clean, %, $@) clean ; \

# minisat 2 download, for your convenience

minisat2-download:
	@echo "Downloading Minisat 2.2.0"
	@lwp-download http://ftp.debian.org/debian/pool/main/m/minisat2/minisat2_2.2.0.orig.tar.gz
	@tar xfz minisat2_2.2.0.orig.tar.gz
	@rm -Rf ../minisat-2.2.0
	@mv minisat-2.2.0 ../minisat-2.2.0
	@(cd ../minisat-2.2.0; patch -p1 < ../scripts/minisat-2.2.0-patch)
	@rm minisat2_2.2.0.orig.tar.gz

=== src/cbmc/Makefile ===
SRC = cbmc_main.cpp cbmc_parse_options.cpp bmc.cpp dimacs.cpp \
      cbmc_languages.cpp counterexample_beautification.cpp \
      bv_cbmc.cpp symex_bmc.cpp show_vcc.cpp cbmc_solvers.cpp \
      xml_interface.cpp cover.cpp all_properties.cpp      

OBJ += ../ansi-c/ansi-c$(LIBEXT) \
      ../linking/linking$(LIBEXT) \
      ../big-int/big-int$(LIBEXT) \
      ../goto-programs/goto-programs$(LIBEXT) \
      ../goto-symex/goto-symex$(LIBEXT) \
      ../pointer-analysis/value_set$(OBJEXT) \
      ../pointer-analysis/value_set_dereference$(OBJEXT) \
      ../pointer-analysis/dereference_callback$(OBJEXT) \
      ../pointer-analysis/add_failed_symbols$(OBJEXT) \
      ../pointer-analysis/rewrite_index$(OBJEXT) \
      ../pointer-analysis/goto_program_dereference$(OBJEXT) \
      ../analyses/analyses$(LIBEXT) \
      ../langapi/langapi$(LIBEXT) \
      ../xmllang/xmllang$(LIBEXT) \
      ../assembler/assembler$(LIBEXT) \
      ../solvers/solvers$(LIBEXT) \
      ../util/util$(LIBEXT)

INCLUDES= -I ..

LIBS =

include ../config.inc
include ../common

CLEANFILES = cbmc$(EXEEXT)

all: cbmc$(EXEEXT)

ifneq ($(wildcard ../bv_refinement/Makefile),)
  OBJ += ../bv_refinement/bv_refinement$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_BV_REFINEMENT
endif

ifneq ($(wildcard ../cpp/Makefile),)
  OBJ += ../cpp/cpp$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_CPP
endif

ifneq ($(wildcard ../java_bytecode/Makefile),)
  OBJ += ../java_bytecode/java_bytecode$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_JAVA_BYTECODE
endif

ifneq ($(wildcard ../specc/Makefile),)
  OBJ += ../specc/specc$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_SPECC
endif

ifneq ($(wildcard ../php/Makefile),)
  OBJ += ../php/php$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_PHP
endif

###############################################################################

cbmc$(EXEEXT): $(OBJ)
	$(LINKBIN)

.PHONY: cbmc-mac-signed

cbmc-mac-signed: cbmc$(EXEEXT)
	strip cbmc$(EXEEXT) ; codesign -v -s $(OSX_IDENTITY) cbmc$(EXEEXT)

=== src/cpp/Makefile ===
SRC = cpp_id.cpp cpp_language.cpp expr2cpp.cpp cpp_parser.cpp \
      cpp_typecheck.cpp cpp_convert_type.cpp \
      cpp_typecheck_expr.cpp cpp_typecheck_code.cpp \
      cpp_typecheck_type.cpp parse.cpp cpp_parse_tree.cpp \
      cpp_token_buffer.cpp cpp_typecheck_fargs.cpp \
      cpp_typecheck_resolve.cpp cpp_util.cpp cpp_enum_type.cpp \
      cpp_typecheck_function.cpp cpp_typecheck_namespace.cpp \
      cpp_name.cpp cpp_is_pod.cpp cpp_scope.cpp \
      cpp_typecheck_find_constructor.cpp template_map.cpp \
      cpp_scopes.cpp cpp_declarator.cpp cpp_instantiate_template.cpp \
      cpp_internal_additions.cpp cpp_type2name.cpp \
      cpp_typecheck_linkage_spec.cpp \
      cpp_typecheck_template.cpp cpp_typecheck_function_bodies.cpp \
      cpp_typecheck_initializer.cpp cpp_typecheck_compound_type.cpp \
      cpp_constructor.cpp cpp_destructor.cpp \
      cpp_typecheck_conversions.cpp\
      cpp_typecheck_declaration.cpp cpp_declarator_converter.cpp \
      cpp_declaration.cpp cpp_namespace_spec.cpp \
      cpp_typecheck_using.cpp cpp_exception_id.cpp \
      cpp_typecheck_enum_type.cpp cpp_typecheck_bases.cpp \
      cpp_typecheck_constructor.cpp \
      cpp_typecheck_destructor.cpp \
      cpp_typecheck_virtual_table.cpp \
      cpp_typecheck_static_assert.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

CLEANFILES = cpp$(LIBEXT)

all: cpp$(LIBEXT) cpp_parser_test$(EXEEXT) cpp_scanner_test$(EXEEXT)

###############################################################################

cpp$(LIBEXT): $(OBJ)
	$(LINKLIB)

cpp_parser_test$(EXEEXT): cpp_parser_test$(OBJEXT) $(OBJ) ../util/util$(LIBEXT) \
	../ansi-c/ansi-c$(LIBEXT) ../big-int/big-int$(LIBEXT) ../linking/linking$(LIBEXT) \
	../langapi/langapi$(LIBEXT)
	$(LINKBIN)

cpp_scanner_test$(EXEEXT): cpp_scanner_test$(OBJEXT) $(OBJ) ../util/util$(LIBEXT) \
	../ansi-c/ansi-c$(LIBEXT) ../big-int/big-int$(LIBEXT) ../linking/linking$(LIBEXT) \
	../langapi/langapi$(LIBEXT)
	$(LINKBIN)

=== src/goto-instrument/Makefile ===
SRC = goto_instrument_parse_options.cpp rw_set.cpp \
      document_properties.cpp goto_instrument_languages.cpp \
      uninitialized.cpp full_slicer.cpp k_induction.cpp \
      object_id.cpp show_locations.cpp points_to.cpp \
      alignment_checks.cpp race_check.cpp \
      nondet_volatile.cpp interrupt.cpp function.cpp branch.cpp \
      mmio.cpp stack_depth.cpp nondet_static.cpp \
      concurrency.cpp dump_c.cpp dot.cpp havoc_loops.cpp \
      call_sequences.cpp unwind.cpp function_modifies.cpp \
      accelerate/accelerate.cpp accelerate/polynomial.cpp \
      accelerate/scratch_program.cpp accelerate/polynomial_accelerator.cpp \
      accelerate/util.cpp accelerate/trace_automaton.cpp \
      accelerate/enumerating_loop_acceleration.cpp \
      accelerate/all_paths_enumerator.cpp \
      accelerate/sat_path_enumerator.cpp \
      accelerate/disjunctive_polynomial_acceleration.cpp \
      accelerate/cone_of_influence.cpp accelerate/overflow_instrumenter.cpp\
      accelerate/path.cpp accelerate/acceleration_utils.cpp \
      count_eloc.cpp reachability_slicer.cpp goto_program2code.cpp \
      wmm/abstract_event.cpp wmm/fence.cpp wmm/shared_buffers.cpp \
      wmm/cycle_collection.cpp wmm/goto2graph.cpp wmm/weak_memory.cpp \
      wmm/data_dp.cpp wmm/instrumenter_strategies.cpp \
      wmm/event_graph.cpp wmm/pair_collection.cpp \
      goto_instrument_main.cpp

OBJ += ../ansi-c/ansi-c$(LIBEXT) \
      ../cpp/cpp$(LIBEXT) \
      ../linking/linking$(LIBEXT) \
      ../big-int/big-int$(LIBEXT) \
      ../goto-programs/goto-programs$(LIBEXT) \
      ../goto-symex/goto-symex$(LIBEXT) \
      ../assembler/assembler$(LIBEXT) \
      ../pointer-analysis/pointer-analysis$(LIBEXT) \
      ../analyses/analyses$(LIBEXT) \
      ../langapi/langapi$(LIBEXT) \
      ../xmllang/xmllang$(LIBEXT) \
      ../util/util$(LIBEXT) \
      ../solvers/solvers$(LIBEXT)

INCLUDES= -I ..

LIBS = 

CLEANFILES = goto-instrument$(EXEEXT)

include ../config.inc
include ../common

all: goto-instrument$(EXEEXT)

ifneq ($(LIB_GLPK),)
  LIBS += $(LIB_GLPK)
  CP_CXXFLAGS += -DHAVE_GLPK
endif

###############################################################################

goto-instrument$(EXEEXT): $(OBJ)
	$(LINKBIN)

.PHONY: goto-instrument-mac-signed

goto-instrument-mac-signed: goto-instrument$(EXEEXT)
	codesign -v -s $(OSX_IDENTITY) goto-instrument$(EXEEXT)

=== src/goto-programs/Makefile ===
SRC = goto_convert.cpp goto_convert_function_call.cpp \
      goto_convert_side_effect.cpp goto_program.cpp basic_blocks.cpp \
      goto_convert_exceptions.cpp property_checker.cpp \
      remove_function_pointers.cpp goto_functions.cpp goto_inline.cpp \
      remove_skip.cpp goto_convert_functions.cpp string_instrumentation.cpp \
      builtin_functions.cpp show_properties.cpp set_properties.cpp \
      read_goto_binary.cpp goto_asm.cpp elf_reader.cpp \
      string_abstraction.cpp destructor.cpp remove_asm.cpp \
      read_bin_goto_object.cpp goto_program_irep.cpp interpreter.cpp \
      interpreter_evaluate.cpp flow_insensitive_analysis.cpp \
      format_strings.cpp loop_ids.cpp pointer_arithmetic.cpp \
      goto_program_template.cpp write_goto_binary.cpp remove_unreachable.cpp \
      remove_unused_functions.cpp remove_vector.cpp \
      wp.cpp goto_rw.cpp goto_clean_expr.cpp safety_checker.cpp \
      compute_called_functions.cpp link_to_library.cpp \
      remove_returns.cpp osx_fat_reader.cpp remove_complex.cpp \
      goto_trace.cpp xml_goto_trace.cpp vcd_goto_trace.cpp graphml_goto_trace.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

LIBS = ../ansi-c/ansi-c$(LIBEXT) \
       ../cpp/cpp$(LIBEXT) \
       ../linking/linking$(LIBEXT) \
       ../util/util$(LIBEXT) \
       ../big-int/big-int$(LIBEXT) \
       ../pointer-analysis/pointer-analysis$(LIBEXT) \
       ../langapi/langapi$(LIBEXT) \
       ../assembler/assembler$(LIBEXT) \
       ../analyses/analyses$(LIBEXT)

CLEANFILES = goto-programs$(LIBEXT) test_wp$(EXEEXT) osx_fat_reader_test$(EXEEXT)

all: goto-programs$(LIBEXT)

###############################################################################

goto-programs$(LIBEXT): $(OBJ)
	$(LINKLIB)

test_wp$(EXEEXT): test_wp$(OBJEXT) goto-programs$(LIBEXT)
	$(LINKBIN)

osx_fat_reader_test$(EXEEXT): osx_fat_reader_test$(OBJEXT) goto-programs$(LIBEXT)
	$(LINKBIN)

=== src/json/Makefile ===
SRC = json.cpp json_parser.cpp json_y.tab.cpp json_lex.yy.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

CLEANFILES=json$(LIBEXT) json_y.tab.h json_y.tab.cpp json_lex.yy.cpp \
           json_y.tab.cpp.output json_y.output \
           json_test$(EXEEXT) json_test$(OBJEXT)

all: json$(LIBEXT) json_test$(EXEEXT)

###############################################################################

json$(LIBEXT): $(OBJ)
	$(LINKLIB)

json_y.tab.cpp: parser.y
	$(YACC) $(YFLAGS) $$flags -pyyjson -d parser.y -o $@

json_y.tab.h: json_y.tab.cpp
	if [ -e json_y.tab.hpp ] ; then mv json_y.tab.hpp $@ ; else \
        mv json_y.tab.cpp.h $@ ; fi

json_lex.yy.cpp: scanner.l
	$(LEX) -Pyyjson -o$@ scanner.l

generated_files: json_lex.yy.cpp json_y.tab.cpp json_y.tab.h

# extra dependencies
json_y.tab$(OBJEXT): json_y.tab.cpp json_y.tab.h
json_lex.yy$(OBJEXT): json_y.tab.cpp json_lex.yy.cpp json_y.tab.h

json_test$(EXEEXT): json_test$(OBJEXT) $(OBJ) ../util/util$(LIBEXT) ../big-int/big-int$(LIBEXT)
	$(LINKBIN)

=== src/musketeer/Makefile ===
SRC = languages.cpp fencer.cpp fence_inserter.cpp musketeer_main.cpp \
      musketeer_parseoptions.cpp fence_assert.cpp fence_user_def.cpp \
      fence_shared.cpp pensieve.cpp propagate_const_function_pointers.cpp \
      graph_visitor.cpp cycles_visitor.cpp

OBJ += ../ansi-c/ansi-c$(LIBEXT) \
      ../linking/linking$(LIBEXT) \
      ../big-int/big-int$(LIBEXT) \
      ../goto-programs/goto-programs$(LIBEXT) \
      ../goto-symex/goto-symex$(LIBEXT) \
      ../assembler/assembler$(LIBEXT) \
      ../pointer-analysis/pointer-analysis$(LIBEXT) \
      ../analyses/analyses$(LIBEXT) \
      ../langapi/langapi$(LIBEXT) \
      ../util/util$(LIBEXT) \
      ../solvers/solvers$(LIBEXT) \
      ../goto-instrument/wmm/weak_memory$(OBJEXT) \
      ../goto-instrument/wmm/fence$(OBJEXT) \
      ../goto-instrument/wmm/event_graph$(OBJEXT) \
      ../goto-instrument/wmm/goto2graph$(OBJEXT) \
      ../goto-instrument/wmm/data_dp$(OBJEXT) \
      ../goto-instrument/wmm/abstract_event$(OBJEXT) \
      ../goto-instrument/wmm/instrumenter_strategies$(OBJEXT) \
      ../goto-instrument/wmm/cycle_collection$(OBJEXT) \
      ../goto-instrument/wmm/shared_buffers$(OBJEXT) \
      ../goto-instrument/wmm/pair_collection$(OBJEXT) \
      ../goto-instrument/rw_set$(OBJEXT)

INCLUDES= -I ..

LIBS =

CLEANFILES = musketeer$(EXEEXT)

include ../config.inc
include ../common

all: musketeer$(EXEEXT)

ifneq ($(LIB_GLPK),)
  LIBS += $(LIB_GLPK)
  CP_CXXFLAGS += -DHAVE_GLPK
endif

###############################################################################

musketeer$(EXEEXT): $(OBJ)
	$(LINKBIN)

.PHONY: musketeer-mac-signed

musketeer-mac-signed: musketeer$(EXEEXT)
	codesign -v -s $(OSX_IDENTITY) musketeer$(EXEEXT)

=== src/solvers/Makefile ===
include ../config.inc
include ../common

ifneq ($(CHAFF),)
  CHAFF_SRC=sat/satcheck_zchaff.cpp sat/satcheck_zcore.cpp
  CHAFF_INCLUDE=-I $(CHAFF)
  CHAFF_LIB=$(CHAFF)/libsat$(LIBEXT)
endif

ifneq ($(MINISAT),)
  MINISAT_SRC=sat/satcheck_minisat.cpp
  MINISAT_INCLUDE=-I $(MINISAT)
  MINISAT_LIB=$(MINISAT)/Solver$(OBJEXT) $(MINISAT)/Proof$(OBJEXT) $(MINISAT)/File$(OBJEXT)
  CP_CXXFLAGS += -DHAVE_MINISAT
endif

ifneq ($(MINISAT2),)
  MINISAT2_SRC=sat/satcheck_minisat2.cpp
  MINISAT2_INCLUDE=-I $(MINISAT2)
  MINISAT2_LIB=$(MINISAT2)/simp/SimpSolver$(OBJEXT) $(MINISAT2)/core/Solver$(OBJEXT)
  CP_CXXFLAGS += -DHAVE_MINISAT2 -D__STDC_FORMAT_MACROS -D__STDC_LIMIT_MACROS
  override CXXFLAGS := $(filter-out -pedantic, $(CXXFLAGS))
endif

ifneq ($(GLUCOSE),)
  GLUCOSE_SRC=sat/satcheck_glucose.cpp
  GLUCOSE_INCLUDE=-I $(GLUCOSE)
  GLUCOSE_LIB=$(GLUCOSE)/simp/SimpSolver$(OBJEXT) $(GLUCOSE)/core/Solver$(OBJEXT)
  CP_CXXFLAGS += -DHAVE_GLUCOSE -D__STDC_FORMAT_MACROS -D__STDC_LIMIT_MACROS
  override CXXFLAGS := $(filter-out -pedantic, $(CXXFLAGS))
endif

ifneq ($(SMVSAT),)
  SMVSAT_SRC=sat/satcheck_smvsat.cpp
  SMVSAT_INCLUDE=-I $(SMVSAT)/include
  SMVSAT_LIB=$(SMVSAT)/lib/libsmvsat$(LIBEXT)
endif

ifneq ($(SQUOLEM2),)
  SQUOLEM2_SRC=qbf/qbf_squolem.cpp qbf/qbf_squolem_core.cpp
  SQUOLEM2_INCLUDE=-I $(SQUOLEM2)
  SQUOLEM2_LIB=-L $(SQUOLEM2) -lsquolem2
endif

ifneq ($(CUDD),)
  CUDD_SRC=qbf/qbf_bdd_core.cpp qbf/qbf_skizzo_core.cpp
  CUDD_INCLUDE=-I $(CUDD)/include
  CUDD_LIB=-L $(CUDD)/cudd -L $(CUDD)/util -L $(CUDD)/mtr \
           -L $(CUDD)/st -L $(CUDD)/obj -L $(CUDD)/dddmp \
           -L $(CUDD)/epd -lobj -lcudd -lmtr -lst -lutil -lepd -ldddmp
endif

ifneq ($(PRECOSAT),)
  PRECOSAT_SRC=sat/satcheck_precosat.cpp
  PRECOSAT_INCLUDE=-I $(PRECOSAT)
  PRECOSAT_LIB=$(PRECOSAT)/precosat$(OBJEXT)
  CP_CXXFLAGS += -DHAVE_PRECOSAT
endif

ifneq ($(PICOSAT),)
  PICOSAT_SRC=sat/satcheck_picosat.cpp
  PICOSAT_INCLUDE=-I $(PICOSAT)
  PICOSAT_LIB=$(PICOSAT)/libpicosat$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_PICOSAT
endif

ifneq ($(LINGELING),)
  LINGELING_SRC=sat/satcheck_lingeling.cpp
  LINGELING_INCLUDE=-I $(LINGELING)
  LINGELING_LIB=$(LINGELING)/liblgl$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_LINGELING
endif

SRC = $(CHAFF_SRC) $(BOOLEFORCE_SRC) $(MINISAT_SRC) $(MINISAT2_SRC) \
      $(SMVSAT_SRC) $(SQUOLEM2_SRC) $(CUDD_SRC) $(GLUCOSE_SRC) \
      $(PRECOSAT_SRC) $(PICOSAT_SRC) $(LINGELING_SRC) \
      sat/cnf.cpp sat/dimacs_cnf.cpp sat/cnf_clause_list.cpp \
      sat/pbs_dimacs_cnf.cpp sat/read_dimacs_cnf.cpp \
      sat/resolution_proof.cpp sat/satcheck.cpp \
      qbf/qdimacs_cnf.cpp qbf/qbf_quantor.cpp \
      qbf/qbf_skizzo.cpp qbf/qdimacs_core.cpp qbf/qbf_qube.cpp \
      qbf/qbf_qube_core.cpp \
      prop/prop.cpp prop/prop_conv.cpp prop/prop_conv_store.cpp \
      prop/cover_goals.cpp prop/literal.cpp \
      prop/aig.cpp prop/aig_prop.cpp prop/minimize.cpp \
      prop/prop_assignment.cpp \
      cvc/cvc_conv.cpp cvc/cvc_dec.cpp \
      smt1/smt1_dec.cpp smt1/smt1_conv.cpp \
      smt2/smt2_dec.cpp smt2/smt2_conv.cpp smt2/smt2_parser.cpp smt2/smt2irep.cpp \
      flattening/equality.cpp flattening/arrays.cpp \
      flattening/functions.cpp flattening/bv_minimize.cpp \
      flattening/boolbv_width.cpp flattening/boolbv.cpp \
      flattening/boolbv_constraint_select_one.cpp \
      flattening/bv_pointers.cpp flattening/bv_utils.cpp \
      flattening/boolbv_abs.cpp flattening/boolbv_with.cpp \
      flattening/boolbv_typecast.cpp flattening/boolbv_index.cpp \
      flattening/boolbv_member.cpp flattening/boolbv_if.cpp \
      flattening/boolbv_byte_extract.cpp flattening/boolbv_add_sub.cpp \
      flattening/boolbv_mult.cpp flattening/boolbv_constant.cpp \
      flattening/boolbv_extractbit.cpp flattening/boolbv_bv_rel.cpp \
      flattening/boolbv_shift.cpp flattening/boolbv_case.cpp \
      flattening/boolbv_cond.cpp flattening/boolbv_concatenation.cpp \
      flattening/boolbv_div.cpp flattening/boolbv_mod.cpp \
      flattening/boolbv_extractbits.cpp flattening/boolbv_replication.cpp \
      flattening/boolbv_reduction.cpp flattening/boolbv_overflow.cpp \
      flattening/boolbv_get.cpp flattening/boolbv_bitwise.cpp \
      flattening/boolbv_equality.cpp flattening/boolbv_unary_minus.cpp \
      flattening/boolbv_ieee_float_rel.cpp flattening/pointer_logic.cpp \
      flattening/boolbv_quantifier.cpp flattening/boolbv_struct.cpp \
      flattening/boolbv_byte_update.cpp flattening/boolbv_array_of.cpp \
      flattening/boolbv_map.cpp flattening/boolbv_type.cpp \
      flattening/boolbv_array.cpp flattening/boolbv_vector.cpp \
      flattening/boolbv_complex.cpp flattening/boolbv_floatbv_op.cpp \
      flattening/boolbv_union.cpp flattening/flatten_byte_operators.cpp \
      flattening/boolbv_update.cpp flattening/c_bit_field_replacement_type.cpp \
      floatbv/float_utils.cpp floatbv/float_bv.cpp \
      refinement/bv_refinement_loop.cpp refinement/refine_arithmetic.cpp \
      refinement/refine_arrays.cpp

INCLUDES= -I .. \
  $(CHAFF_INCLUDE) $(BOOLEFORCE_INCLUDE) $(MINISAT_INCLUDE) $(MINISAT2_INCLUDE) \
  $(SMVSAT_INCLUDE) $(SQUOLEM2_INC) $(CUDD_INCLUDE) $(GLUCOSE_INCLUDE) \
	$(PRECOSAT_INCLUDE) $(PICOSAT_INCLUDE) $(LINGELING_INCLUDE)

CLEANFILES = solvers$(LIBEXT)

all: solvers$(LIBEXT) smt2/smt2_parser_test$(EXEEXT)

ifneq ($(SQUOLEM2),)
  CP_CXXFLAGS += -DHAVE_QBF_CORE
else
ifneq ($(CUDD),)
  CP_CXXFLAGS += -DHAVE_QBF_CORE
endif
endif

# extra dependencies

-include $(SRC:.cpp=.d)

###############################################################################

solvers$(LIBEXT): $(OBJ) $(CHAFF_LIB) $(BOOLEFORCE_LIB) $(MINISAT_LIB) \
        $(MINISAT2_LIB) $(SMVSAT_LIB) $(SQUOLEM2_LIB) $(CUDD_LIB) \
	$(PRECOSAT_LIB) $(PICOSAT_LIB) $(LINGELING_LIB) $(GLUCOSE_LIB)
	$(LINKLIB)

smt2/smt2_parser_test$(EXEEXT): smt2/smt2_parser$(OBJEXT) smt2/smt2_parser_test$(OBJEXT)
	$(LINKBIN)

=== src/util/Makefile ===
SRC = arith_tools.cpp base_type.cpp cmdline.cpp config.cpp symbol_table.cpp \
      expr.cpp expr_util.cpp i2string.cpp irep.cpp language.cpp \
      lispexpr.cpp lispirep.cpp source_location.cpp message.cpp language_file.cpp \
      mp_arith.cpp namespace.cpp parse_options.cpp rename.cpp \
      replace_expr.cpp threeval.cpp typecheck.cpp graph.cpp \
      type.cpp cnf_simplify.cpp pointer_predicates.cpp merge_irep.cpp \
      bitvector.cpp parser.cpp replace_symbol.cpp actuals.cpp \
      get_module.cpp string_hash.cpp string_container.cpp identifier.cpp \
      rational.cpp options.cpp c_misc.cpp simplify_expr.cpp dstring.cpp \
      find_symbols.cpp rational_tools.cpp ui_message.cpp simplify_utils.cpp \
      time_stopping.cpp symbol.cpp irep_hash_container.cpp cout_message.cpp \
      type_eq.cpp guard.cpp array_name.cpp message_stream.cpp \
      substitute.cpp decision_procedure.cpp union_find.cpp \
      xml.cpp xml_irep.cpp xml_expr.cpp std_types.cpp std_code.cpp \
      format_constant.cpp find_macros.cpp ref_expr_set.cpp std_expr.cpp \
      irep_serialization.cpp fixedbv.cpp rename_symbol.cpp \
      ieee_float.cpp signal_catcher.cpp pointer_offset_size.cpp \
      bv_arithmetic.cpp tempdir.cpp tempfile.cpp timer.cpp unicode.cpp \
      irep_ids.cpp byte_operators.cpp string2int.cpp file_util.cpp \
      memory_info.cpp pipe_stream.cpp irep_hash.cpp endianness_map.cpp 

INCLUDES= -I ..

LIBS = ../big-int/bigint$(OBJEXT) ../big-int/bigint-func$(OBJEXT)

include ../config.inc
include ../common

CLEANFILES = util$(LIBEXT) \
             irep_ids.h irep_ids.inc \
             ieee_float_test$(EXEEXT) ieee_float_test$(OBJEXT) ieee_float_test.d \
             irep_ids_convert$(EXEEXT) irep_ids_convert$(OBJEXT) irep_ids_convert.d

all: util$(LIBEXT) ieee_float_test$(EXEEXT)

###############################################################################

irep_ids.h: irep_ids_convert$(EXEEXT) irep_ids.txt
	./irep_ids_convert$(EXEEXT) header < irep_ids.txt > $@

irep_ids.inc: irep_ids_convert$(EXEEXT) irep_ids.txt
	./irep_ids_convert$(EXEEXT) table < irep_ids.txt > $@

irep_ids.cpp: irep_ids.inc irep_ids.h

irep_ids_convert$(EXEEXT): irep_ids_convert.cpp
	$(LINKNATIVE)

generated_files: irep_ids.h irep_ids.inc

# Most of the others will need irep_ids.h,
# which we first need to generate.
$(OBJ): irep_ids.h

util$(LIBEXT): $(OBJ)
	$(LINKLIB)

ieee_float_test$(OBJEXT): irep_ids.h  

ieee_float_test$(EXEEXT): ieee_float_test$(OBJEXT) util$(LIBEXT)
	$(LINKBIN)

=== debian/changelog ===
cbmc (5.1-1~bpo8+1) jessie-backports; urgency=low

  * Upload to backports
  * Proper cleanup (from future 5.1-2)

 -- Michael Tautschnig <mt@debian.org>  Mon, 11 May 2015 11:55:38 +0100

cbmc (5.1-1) unstable; urgency=low

  * New upstream release
  * Most 5.0 patches merged

 -- Michael Tautschnig <mt@debian.org>  Mon, 11 May 2015 00:39:01 +0100

## cbmc 5.2

=== src/analyses/Makefile ===
SRC = natural_loops.cpp is_threaded.cpp dirty.cpp interval_analysis.cpp \
      invariant_set.cpp invariant_set_domain.cpp invariant_propagation.cpp \
      static_analysis.cpp uninitialized_domain.cpp local_may_alias.cpp \
      locals.cpp goto_check.cpp call_graph.cpp interval_domain.cpp \
      goto_rw.cpp reaching_definitions.cpp ai.cpp local_cfg.cpp \
      local_bitvector_analysis.cpp dependence_graph.cpp \
      custom_bitvector_analysis.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

CLEANFILES = analyses$(LIBEXT)

all: analyses$(LIBEXT)

###############################################################################

analyses$(LIBEXT): $(OBJ) 
	$(LINKLIB)

=== src/ansi-c/Makefile ===
SRC = c_typecast.cpp ansi_c_y.tab.cpp ansi_c_lex.yy.cpp ansi_c_parser.cpp \
      expr2c.cpp ansi_c_language.cpp c_sizeof.cpp ansi_c_scope.cpp \
      c_types.cpp trans_unit.cpp ansi_c_typecheck.cpp \
      c_preprocess.cpp c_storage_spec.cpp \
      c_typecheck_base.cpp c_typecheck_initializer.cpp \
      c_typecheck_typecast.cpp c_typecheck_code.cpp \
      c_typecheck_expr.cpp c_typecheck_type.cpp string_constant.cpp \
      c_qualifiers.cpp c_typecheck_argc_argv.cpp ansi_c_parse_tree.cpp \
      preprocessor_line.cpp ansi_c_convert_type.cpp \
      type2name.cpp cprover_library.cpp anonymous_member.cpp \
      printf_formatter.cpp ansi_c_internal_additions.cpp padding.cpp \
      ansi_c_declaration.cpp designator.cpp \
      literals/parse_float.cpp literals/unescape_string.cpp \
      literals/convert_float_literal.cpp \
      literals/convert_character_literal.cpp \
      literals/convert_integer_literal.cpp \
      literals/convert_string_literal.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

CLEANFILES = ansi-c$(LIBEXT) \
  ansi_c_y.tab.h ansi_c_y.tab.cpp ansi_c_lex.yy.cpp ansi_c_y.tab.cpp.output \
  ansi_c_y.output \
  library/converter$(EXEEXT) cprover_library.inc \
  file_converter$(EXEEXT) library_check \
  gcc_builtin_headers_generic.inc gcc_builtin_headers_ia32.inc \
  arm_builtin_headers.inc cw_builtin_headers.inc \
  gcc_builtin_headers_arm.inc gcc_builtin_headers_alpha.inc \
  gcc_builtin_headers_mips.inc gcc_builtin_headers_power.inc \
	clang_builtin_headers.inc gcc_builtin_headers_ia32-2.inc

all: ansi-c$(LIBEXT)

###############################################################################

ansi_c_y.tab.cpp: parser.y
	$(YACC) $(YFLAGS) $$flags -pyyansi_c -d parser.y -o $@

ansi_c_y.tab.h: ansi_c_y.tab.cpp
	if [ -e ansi_c_y.tab.hpp ] ; then mv ansi_c_y.tab.hpp ansi_c_y.tab.h ; else \
        mv ansi_c_y.tab.cpp.h ansi_c_y.tab.h ; fi

ansi_c_lex.yy.cpp: scanner.l
	$(LEX) -Pyyansi_c -o$@ scanner.l

# extra dependencies
ansi_c_y.tab$(OBJEXT): ansi_c_y.tab.cpp ansi_c_y.tab.h
ansi_c_lex.yy$(OBJEXT): ansi_c_y.tab.cpp ansi_c_lex.yy.cpp ansi_c_y.tab.h
cprover_library$(OBJEXT): cprover_library.inc

###############################################################################

library/converter$(EXEEXT): library/converter.cpp
	$(LINKNATIVE)

file_converter$(EXEEXT): file_converter.cpp
	$(LINKNATIVE)

ifeq ($(BUILD_ENV),MinGW)
  platform_unavail = library/err.c library/threads.c
else
  platform_unavail = library/threads.c
endif
library_check: library/*.c
	for f in $(filter-out $(platform_unavail), $^) ; do \
		cp $$f __libcheck.c ; \
		sed -i 's/__builtin_[^v]/s&/' __libcheck.c ; \
		sed -i 's/__sync_/s&/' __libcheck.c ; \
		sed -i 's/__noop/s&/' __libcheck.c ; \
		$(CC) -std=gnu99 -E -include library/cprover.h -D__CPROVER_bool=_Bool \
			-D__CPROVER_thread_local=__thread -DLIBRARY_CHECK -o __libcheck.i __libcheck.c ; \
		$(CC) -S -Wall -Werror -pedantic -Wextra -std=gnu99 __libcheck.i -o __libcheck.s \
			-Wno-unused-label -Wno-uninitialized ; \
		ec=$$? ; \
		$(RM) __libcheck.s __libcheck.i __libcheck.c ; \
		[ $$ec -eq 0 ] || exit $$ec ; \
	done
	touch $@
	
cprover_library.inc: library/converter$(EXEEXT) library/*.c
	cat library/*.c | library/converter$(EXEEXT) > $@

%.inc: %.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < $< > $@

cprover_library.cpp: cprover_library.inc

ansi_c_internal_additions$(OBJEXT): gcc_builtin_headers_generic.inc
ansi_c_internal_additions$(OBJEXT): gcc_builtin_headers_ia32.inc
ansi_c_internal_additions$(OBJEXT): gcc_builtin_headers_ia32-2.inc
ansi_c_internal_additions$(OBJEXT): gcc_builtin_headers_alpha.inc
ansi_c_internal_additions$(OBJEXT): gcc_builtin_headers_arm.inc
ansi_c_internal_additions$(OBJEXT): gcc_builtin_headers_mips.inc
ansi_c_internal_additions$(OBJEXT): gcc_builtin_headers_power.inc
ansi_c_internal_additions$(OBJEXT): arm_builtin_headers.inc
ansi_c_internal_additions$(OBJEXT): cw_builtin_headers.inc
ansi_c_internal_additions$(OBJEXT): clang_builtin_headers.inc

generated_files: cprover_library.inc gcc_builtin_headers_generic.inc \
	gcc_builtin_headers_ia32.inc gcc_builtin_headers_alpha.inc \
	gcc_builtin_headers_arm.inc gcc_builtin_headers_mips.inc \
	gcc_builtin_headers_power.inc arm_builtin_headers.inc \
	cw_builtin_headers.inc ansi_c_y.tab.cpp ansi_c_lex.yy.cpp \
	ansi_c_y.tab.h clang_builtin_headers.inc gcc_builtin_headers_ia32-2.inc

###############################################################################

ansi-c$(LIBEXT): $(OBJ) 
	$(LINKLIB)

=== src/cegis/Makefile ===
SRC = bmc/bmc_verification_oracle.cpp symex/symex_learn.cpp \
      symex/variables_factory.cpp symex/candidate_factory.cpp \
      symex/symex_learning_program_adapter.cpp symex/cegis_library.cpp \
      symex/target_program_factory.cpp symex/test_case_factory.cpp \
      util/goto_program_adapter.cpp util/source_location_factory.cpp \
      util/symbol_table_adapter.cpp options/cegis_options.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

CLEANFILES = cegis$(LIBEXT)

all: cegis$(LIBEXT)

###############################################################################

cegis$(LIBEXT): $(OBJ)
	$(LINKLIB)

=== src/cpp/Makefile ===
--- 
+++ 
@@ -28,7 +28,10 @@
 include ../config.inc
 include ../common
 
-CLEANFILES = cpp$(LIBEXT)
+CLEANFILES = cpp$(LIBEXT) \
+             cpp_parser_test$(EXEEXT) cpp_scanner_test$(EXEEXT) \
+             cpp_parser_test$(OBJEXT) cpp_scanner_test$(OBJEXT) \
+             cpp_parser_test.d cpp_scanner_test.d
 
 all: cpp$(LIBEXT) cpp_parser_test$(EXEEXT) cpp_scanner_test$(EXEEXT)

=== src/goto-instrument/Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
       wmm/cycle_collection.cpp wmm/goto2graph.cpp wmm/weak_memory.cpp \
       wmm/data_dp.cpp wmm/instrumenter_strategies.cpp \
       wmm/event_graph.cpp wmm/pair_collection.cpp \
-      goto_instrument_main.cpp
+      goto_instrument_main.cpp horn_encoding.cpp
 
 OBJ += ../ansi-c/ansi-c$(LIBEXT) \
       ../cpp/cpp$(LIBEXT) \

=== src/goto-programs/Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
       format_strings.cpp loop_ids.cpp pointer_arithmetic.cpp \
       goto_program_template.cpp write_goto_binary.cpp remove_unreachable.cpp \
       remove_unused_functions.cpp remove_vector.cpp \
-      wp.cpp goto_rw.cpp goto_clean_expr.cpp safety_checker.cpp \
+      wp.cpp goto_clean_expr.cpp safety_checker.cpp \
       compute_called_functions.cpp link_to_library.cpp \
       remove_returns.cpp osx_fat_reader.cpp remove_complex.cpp \
       goto_trace.cpp xml_goto_trace.cpp vcd_goto_trace.cpp graphml_goto_trace.cpp

=== src/util/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
       mp_arith.cpp namespace.cpp parse_options.cpp rename.cpp \
       replace_expr.cpp threeval.cpp typecheck.cpp graph.cpp \
       type.cpp cnf_simplify.cpp pointer_predicates.cpp merge_irep.cpp \
-      bitvector.cpp parser.cpp replace_symbol.cpp actuals.cpp \
+      bitvector.cpp parser.cpp replace_symbol.cpp \
       get_module.cpp string_hash.cpp string_container.cpp identifier.cpp \
       rational.cpp options.cpp c_misc.cpp simplify_expr.cpp dstring.cpp \
       find_symbols.cpp rational_tools.cpp ui_message.cpp simplify_utils.cpp \
@@ -17,7 +17,8 @@
       ieee_float.cpp signal_catcher.cpp pointer_offset_size.cpp \
       bv_arithmetic.cpp tempdir.cpp tempfile.cpp timer.cpp unicode.cpp \
       irep_ids.cpp byte_operators.cpp string2int.cpp file_util.cpp \
-      memory_info.cpp pipe_stream.cpp irep_hash.cpp endianness_map.cpp 
+      memory_info.cpp pipe_stream.cpp irep_hash.cpp endianness_map.cpp \
+      vtable.cpp 
 
 INCLUDES= -I ..

=== debian/changelog ===
cbmc (5.2-1~bpo8+1) jessie-backports; urgency=low

  * Upload to backports

 -- Michael Tautschnig <mt@debian.org>  Mon, 14 Sep 2015 18:34:18 +0100

cbmc (5.2-1) unstable; urgency=low

  * New upstream release

 -- Michael Tautschnig <mt@debian.org>  Wed, 02 Sep 2015 14:37:38 +0100

cbmc (5.1-2) unstable; urgency=low

  * Proper cleanup

 -- Michael Tautschnig <mt@debian.org>  Mon, 11 May 2015 13:18:40 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_CXXFLAGS_MAINT_APPEND := -Wall -O2 -g -Werror -Wno-long-long -Wno-sign-compare -Wno-parentheses -Wno-strict-aliasing -pedantic

%:
	dh $@ --parallel

override_dh_auto_clean:
	dh_auto_clean
	$(MAKE) -C src clean
	$(RM) regression/*/tests.log
	$(RM) regression/*/*/*.out

override_dh_auto_build:
	$(MAKE) -C src MINISAT2=/usr/include/minisat

override_dh_auto_test:
	cd regression/ansi-c ; \
		if ! ../test.pl -c ../../../src/goto-cc/goto-cc ; then \
		  ../../debian/failed-tests-printer.pl ; \
			exit 1 ; \
		fi
	cd regression/cpp ; \
		if ! ../test.pl -c ../../../src/goto-cc/goto-cc ; then \
		  ../../debian/failed-tests-printer.pl ; \
			exit 1 ; \
		fi
	cd regression/cbmc ; \
		if ! ../test.pl -c ../../../src/cbmc/cbmc ; then \
		  ../../debian/failed-tests-printer.pl ; \
			exit 1 ; \
		fi
	cd regression/cbmc-concurrency ; \
		if ! ../test.pl -c ../../../src/cbmc/cbmc ; then \
		  ../../debian/failed-tests-printer.pl ; \
			exit 1 ; \
		fi

DEB_VERS=5.2
get-orig-source:
	svn export http://svn.cprover.org/svn/cbmc/releases/cbmc-$(DEB_VERS)
	tar cf cbmc_$(DEB_VERS).orig.tar cbmc-$(DEB_VERS)
	rm -rf cbmc-$(DEB_VERS)
	gzip -9n cbmc_$(DEB_VERS).orig.tar

## cbmc 5.3

=== regression/Makefile ===
DIRS = ansi-c cbmc cpp 

test:
	$(foreach var,$(DIRS), $(MAKE) -C $(var) test;)

=== src/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 DIRS = ansi-c big-int cbmc cpp goto-cc goto-instrument goto-programs \
        goto-symex langapi pointer-analysis solvers util linking xmllang \
        assembler analyses java_bytecode aa-path-symex path-symex musketeer \
-       json
+       json cegis
 
 all: cbmc.dir goto-cc.dir goto-instrument.dir path-symex.dir json.dir
 
@@ -9,7 +9,7 @@
 
 util.dir: big-int.dir
 
-# everything depends on util
+# everything but big-int depends on util
 $(patsubst %, %.dir, $(filter-out big-int util, $(DIRS))): util.dir
 
 .PHONY: languages
@@ -26,7 +26,8 @@
 musketeer.dir: goto-instrument.dir
 
 cbmc.dir: languages solvers.dir goto-symex.dir analyses.dir \
-          pointer-analysis.dir goto-programs.dir linking.dir
+          pointer-analysis.dir goto-programs.dir linking.dir \
+          cegis.dir goto-instrument.dir
 
 goto-cc.dir: languages pointer-analysis.dir goto-programs.dir linking.dir
 
@@ -60,3 +61,13 @@
 	@mv minisat-2.2.0 ../minisat-2.2.0
 	@(cd ../minisat-2.2.0; patch -p1 < ../scripts/minisat-2.2.0-patch)
 	@rm minisat2_2.2.0.orig.tar.gz
+
+glucose-download:
+	@echo "Downloading glucose-syrup"
+	@lwp-download http://www.labri.fr/perso/lsimon/downloads/softwares/glucose-syrup.tgz
+	@tar xfz glucose-syrup.tgz
+	@rm -Rf ../glucose-syrup
+	@mv glucose-syrup ../
+	@(cd ../glucose-syrup; patch -p1 < ../scripts/glucose-syrup-patch)
+	@rm glucose-syrup.tgz
+

=== regression/acceleration/Makefile ===
default: tests.log

test:
	@../test.pl -c ../../../src/goto-instrument/accelerate/accelerate.sh

tests.log: ../test.pl
	@../test.pl -c ../../../src/goto-instrument/accelerate/accelerate.sh

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

clean:
	rm -f tests.log
	rm -f */main.out

=== regression/array-refinement/Makefile ===
default: tests.log

TOOL = "../../../src/cbmc/cbmc"

test:
	@../test.pl -c $(TOOL)

tests.log: ../test.pl
	@../test.pl -c $(TOOL)

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

=== regression/cbmc-incr-oneloop/Makefile ===
default: tests.log

test:
	@../test.pl -c "perl -e 'alarm shift @ARGV; exec @ARGV' 30 ../../../src/cbmc/cbmc --slice-formula"

tests.log: ../test.pl
	@../test.pl -c "perl -e 'alarm shift @ARGV; exec @ARGV' 30 ../../../src/cbmc/cbmc --slice-formula"

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

clean:
	@rm -f *.log
	@(for dir in *; do rm -f $$dir/*.out; done;)

=== regression/cbmc-incr/Makefile ===
default: tests.log

PARAM = --incremental --magic-numbers 
# --refine   --slice-formula

test:
	@../test.pl -c "perl -e 'alarm shift @ARGV; exec @ARGV' 30 ../../../src/cbmc/cbmc $(PARAM)"

tests.log: ../test.pl
	@../test.pl -c "perl -e 'alarm shift @ARGV; exec @ARGV' 30 ../../../src/cbmc/cbmc $(PARAM)"

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

clean:
	@rm -f *.log
	@(for dir in *; do rm -f $$dir/*.out; done;)

=== regression/cbmc-java/Makefile ===
default: tests.log

test:
	@../test.pl -c ../../../src/cbmc/cbmc

tests.log: ../test.pl
	@../test.pl -c ../../../src/cbmc/cbmc

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.java" "$$dir/*.out"; \
		fi; \
	done;

=== regression/cpp-from-CVS/Makefile ===
default: tests.log

test:
	@../test.pl -c cbmc

tests.log: ../test.pl
	@../test.pl -c cbmc

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/main.c" "$$dir/main.out"; \
		fi; \
	done;

=== src/aa-path-symex/Makefile ===
SRC = locs.cpp var_map.cpp path_symex_history.cpp path_symex_state.cpp \
      path_symex.cpp build_goto_trace.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

CLEANFILES = aa-path-symex$(LIBEXT)

all: aa-path-symex$(LIBEXT)

###############################################################################

aa-path-symex$(LIBEXT): $(OBJ)
	$(LINKLIB)

=== src/aa-symex/Makefile ===
SRC = symex_main.cpp symex_parseoptions.cpp path_search.cpp

OBJ += ../ansi-c/ansi-c$(LIBEXT) \
       ../linking/linking$(LIBEXT) \
       ../big-int/big-int$(LIBEXT) \
       ../goto-programs/goto-programs$(LIBEXT) \
       ../analyses/analyses$(LIBEXT) \
       ../langapi/langapi$(LIBEXT) \
       ../xmllang/xmllang$(LIBEXT) \
       ../assembler/assembler$(LIBEXT) \
       ../solvers/solvers$(LIBEXT) \
       ../util/util$(LIBEXT) \
       ../goto-symex/adjust_float_expressions$(OBJEXT) \
       ../pointer-analysis/dereference$(OBJEXT) \
       ../aa-path-symex/aa-path-symex$(LIBEXT)

INCLUDES= -I ..

LIBS =

include ../config.inc
include ../common

CLEANFILES = symex$(EXEEXT)

all: symex$(EXEEXT)

ifneq ($(wildcard ../bv_refinement/Makefile),)
  OBJ += ../bv_refinement/bv_refinement$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_BV_REFINEMENT
endif

ifneq ($(wildcard ../cpp/Makefile),)
  OBJ += ../cpp/cpp$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_CPP
endif

ifneq ($(wildcard ../java_bytecode/Makefile),)
  OBJ += ../java_bytecode/java_bytecode$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_JAVA_BYTECODE
endif

ifneq ($(wildcard ../specc/Makefile),)
  OBJ += ../specc/specc$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_SPECC
endif

ifneq ($(wildcard ../php/Makefile),)
  OBJ += ../php/php$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_PHP
endif

###############################################################################

symex$(EXEEXT): $(OBJ)
	$(LINKBIN)

.PHONY: symex-mac-signed

symex-mac-signed: cbmc$(EXEEXT)
	strip symex$(EXEEXT) ; codesign -v -s $(OSX_IDENTITY) symex$(EXEEXT)

=== src/analyses/Makefile ===
--- 
+++ 
@@ -4,7 +4,8 @@
       locals.cpp goto_check.cpp call_graph.cpp interval_domain.cpp \
       goto_rw.cpp reaching_definitions.cpp ai.cpp local_cfg.cpp \
       local_bitvector_analysis.cpp dependence_graph.cpp \
-      custom_bitvector_analysis.cpp
+      constant_propagator.cpp replace_symbol_ext.cpp \
+      custom_bitvector_analysis.cpp escape_analysis.cpp global_may_alias.cpp
 
 INCLUDES= -I ..

=== src/ansi-c/Makefile ===
--- 
+++ 
@@ -60,9 +60,9 @@
 	$(LINKNATIVE)
 
 ifeq ($(BUILD_ENV),MinGW)
-  platform_unavail = library/err.c library/threads.c
+  platform_unavail = library/java.io.c library/err.c library/threads.c
 else
-  platform_unavail = library/threads.c
+  platform_unavail = library/java.io.c library/threads.c
 endif
 library_check: library/*.c
 	for f in $(filter-out $(platform_unavail), $^) ; do \

=== debian/changelog ===
cbmc (5.3-1) unstable; urgency=low

  * New upstream release
  * non-static-build patch merged
  * Re-licensed Debian packaging to BSD 2-clause

 -- Michael Tautschnig <mt@debian.org>  Wed, 20 Jan 2016 04:03:52 +0000

=== debian/control ===
Source: cbmc
Section: science
Priority: extra
Maintainer: Michael Tautschnig <mt@debian.org>
Build-Depends: debhelper (>= 9), minisat (>= 1:2.2.1-2), zlib1g-dev, flex, bison
Standards-Version: 3.9.6
Homepage: http://www.cprover.org/cbmc/

Package: cbmc
Architecture: any
Depends: gcc, ${shlibs:Depends}, ${misc:Depends}
Description: bounded model checker for C and C++ programs
 CBMC generates traces that demonstrate how an assertion can be violated, or
 proves that the assertion cannot be violated within a given number of loop
 iterations.

=== debian/rules ===
--- 
+++ 
@@ -45,7 +45,7 @@
 			exit 1 ; \
 		fi
 
-DEB_VERS=5.2
+DEB_VERS=5.3
 get-orig-source:
 	svn export http://svn.cprover.org/svn/cbmc/releases/cbmc-$(DEB_VERS)
 	tar cf cbmc_$(DEB_VERS).orig.tar cbmc-$(DEB_VERS)

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

# Uncomment to examine a Webpage
# <Webpage URL> <string match>
http://svn.cprover.org/svn/cbmc/releases/ cbmc-(.*)/
